/*

Copyright (C) 2023 Charadon

This program is free software: you can redistribute it and/or modify it under 
the terms of the GNU Affero General Public License as published by the Free 
Software Foundation, either version 3 of the License, or (at your option) any 
later version.

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more 
details.

You should have received a copy of the GNU Affero General Public License along 
with this program. If not, see <https://www.gnu.org/licenses/>.

*/

function reset_ball() {
  game_has_begun = false;
  ball.speed = 1;
  ball.angle = 0;
  ball.x = 0;
  ball.y = 0;
}

function bounce_ball_from_paddle() {
  if(ball.direction == 'right') {
    ball.direction = 'left';
  } else {
    ball.direction = 'right';
  }
  ball.speed++;
  audio.playSound("bounce");
  var multiplier = 1;
  if(ball.speed > 10) {
    multiplier = 2;
  }
  ball.angle = Math.floor(Math.random()*(4*multiplier));
  if(Math.floor(Math.random()*2) == 0) {
    ball.angle *= -1;
  } 
}

function update_ball() {
  switch(ball.direction) {
    case 'left':
      ball.x -= ball.speed;
      break;
    case 'right':
      ball.x += ball.speed;
      break;
  }
  ball.y += ball.angle;
  if(collision(player.sprite.width, player.sprite.height, player.x, player.y, ball.sprite.width, ball.sprite.height, ball.x, ball.y) == true && ball.direction == 'left') {
    bounce_ball_from_paddle();
  }
  else if(collision(enemy.sprite.width, enemy.sprite.height, enemy.x, enemy.y, ball.sprite.width, ball.sprite.height, ball.x, ball.y) == true && ball.direction == 'right') {
    bounce_ball_from_paddle();
  }
  if(ball.speed > 25) {
    ball.speed = 25;
  }
  if(ball.y > 85 || ball.y < -85) {
    ball.angle *= -1;
    if(ball.y > 85) {
      ball.y = 84;
    } else {
      ball.y = -84;
    }
    audio.playSound("bounce");
  }
  
  if(ball.x < player.x-16) {
    reset_ball();
    enemy.score += 1;
    audio.playSound("score_enemy");
  } else if(ball.x > enemy.x+16) {
    reset_ball();
    player.score += 1;
    audio.playSound("score_player");
  }
}