/*

Copyright (C) 2023 Charadon

This program is free software: you can redistribute it and/or modify it under 
the terms of the GNU Affero General Public License as published by the Free 
Software Foundation, either version 3 of the License, or (at your option) any 
later version.

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more 
details.

You should have received a copy of the GNU Affero General Public License along 
with this program. If not, see <https://www.gnu.org/licenses/>.

*/

var player = {
  y: 0,
  x: -162,
  score: 0,
  sprite: sprites["paddle"],
  cursor_lastpos: 0
};

var enemy = {
  y: 0,
  x: 162,
  score: 0,
  sprite: sprites["paddle"],
};

var ball = {
  x: 0,
  y: 0,
  angle: 0,
  direction: 'left',
  speed: 1,
  sprite: sprites["ball"]
};

var game_has_begun = false;
var game_over = 'none';

init = function() {

}

update = function() {
  if(game_has_begun == true && game_over == 'none') {
    player_controls();
    update_ball();
    update_enemy();
  } else {
    if(keyboard.SPACE) {
      game_has_begun = true;
    }
  }
  if(game_over == 'none') {
    if(enemy.score >= 10) {
      game_over = 'enemy';
      audio.playSound("defeat");
    } else if(player.score >= 10) {
      game_over = 'player';
      audio.playSound("victory");
    }
  }
}

draw = function() {
  screen.clear();
  screen.drawSprite(player.sprite,player.x, player.y, 16, 32);
  screen.drawText("Score: " + player.score,-153,94,12,"#00ff00");
  screen.drawSprite(enemy.sprite,enemy.x, enemy.y, 16, 32);
  screen.drawText("Score: " + enemy.score,153,94,12,"#ff0000");
  screen.drawSprite(ball.sprite, ball.x, ball.y);
  if(game_has_begun == false && game_over == 'none') {
    screen.drawText("Press space to begin.", 0,58, 16,"rgb(255,255,0)");
    screen.drawText("First to 10 wins!", 0, 45, 12,"rgb(255,170,0)");
  }
  if(game_over != 'none') {
    if(game_over == 'enemy') {
      screen.drawText("AI won.", 0, 58, 16,"rgb(255,0,0)");
    } else if(game_over == 'player') {
      screen.drawText("Player won!", 0, 58, 16,"rgb(0,170,0)");
    }
    screen.drawText("Refresh to restart game.", 0, 25, 16,"rgb(255,227,227)");
  }
}